diff --git a/tensorflow/python/eager/pywrap_tfe_src.cc b/tensorflow/python/eager/pywrap_tfe_src.cc
index ba9d8a36b0d..3cbeac1fa20 100644
--- a/tensorflow/python/eager/pywrap_tfe_src.cc
+++ b/tensorflow/python/eager/pywrap_tfe_src.cc
@@ -1319,20 +1319,20 @@ static PyTypeObject TFE_Py_Tape_Type = {
     sizeof(TFE_Py_Tape),                          /* tp_basicsize */
     0,                                            /* tp_itemsize */
     &TFE_Py_Tape_Delete,                          /* tp_dealloc */
-    nullptr,                                      /* tp_print */
-    nullptr,                                      /* tp_getattr */
-    nullptr,                                      /* tp_setattr */
-    nullptr,                                      /* tp_reserved */
-    nullptr,                                      /* tp_repr */
-    nullptr,                                      /* tp_as_number */
-    nullptr,                                      /* tp_as_sequence */
-    nullptr,                                      /* tp_as_mapping */
-    nullptr,                                      /* tp_hash  */
-    nullptr,                                      /* tp_call */
-    nullptr,                                      /* tp_str */
-    nullptr,                                      /* tp_getattro */
-    nullptr,                                      /* tp_setattro */
-    nullptr,                                      /* tp_as_buffer */
+    0,                                      /* tp_print */
+    0,                                      /* tp_getattr */
+    0,                                      /* tp_setattr */
+    0,                                      /* tp_reserved */
+    0,                                      /* tp_repr */
+    0,                                      /* tp_as_number */
+    0,                                      /* tp_as_sequence */
+    0,                                      /* tp_as_mapping */
+    0,                                      /* tp_hash  */
+    0,                                      /* tp_call */
+    0,                                      /* tp_str */
+    0,                                      /* tp_getattro */
+    0,                                      /* tp_setattro */
+    0,                                      /* tp_as_buffer */
     Py_TPFLAGS_DEFAULT,                           /* tp_flags */
     "TFE_Py_Tape objects",                        /* tp_doc */
 };
@@ -1353,20 +1353,20 @@ static PyTypeObject TFE_Py_ForwardAccumulator_Type = {
     sizeof(TFE_Py_ForwardAccumulator),                      /* tp_basicsize */
     0,                                                      /* tp_itemsize */
     &TFE_Py_ForwardAccumulatorDelete,                       /* tp_dealloc */
-    nullptr,                                                /* tp_print */
-    nullptr,                                                /* tp_getattr */
-    nullptr,                                                /* tp_setattr */
-    nullptr,                                                /* tp_reserved */
-    nullptr,                                                /* tp_repr */
-    nullptr,                                                /* tp_as_number */
-    nullptr,                                                /* tp_as_sequence */
-    nullptr,                                                /* tp_as_mapping */
-    nullptr,                                                /* tp_hash  */
-    nullptr,                                                /* tp_call */
-    nullptr,                                                /* tp_str */
-    nullptr,                                                /* tp_getattro */
-    nullptr,                                                /* tp_setattro */
-    nullptr,                                                /* tp_as_buffer */
+    0,                                                /* tp_print */
+    0,                                                /* tp_getattr */
+    0,                                                /* tp_setattr */
+    0,                                                /* tp_reserved */
+    0,                                                /* tp_repr */
+    0,                                                /* tp_as_number */
+    0,                                                /* tp_as_sequence */
+    0,                                                /* tp_as_mapping */
+    0,                                                /* tp_hash  */
+    0,                                                /* tp_call */
+    0,                                                /* tp_str */
+    0,                                                /* tp_getattro */
+    0,                                                /* tp_setattro */
+    0,                                                /* tp_as_buffer */
     Py_TPFLAGS_DEFAULT,                                     /* tp_flags */
     "TFE_Py_ForwardAccumulator objects",                    /* tp_doc */
 };
diff --git a/tensorflow/python/framework/common_shapes.py b/tensorflow/python/framework/common_shapes.py
index 11612295d92..1db0849f8ae 100644
--- a/tensorflow/python/framework/common_shapes.py
+++ b/tensorflow/python/framework/common_shapes.py
@@ -18,7 +18,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-import six.moves
 
 from tensorflow.python import pywrap_tensorflow
 from tensorflow.python.framework import cpp_shape_inference_pb2
diff --git a/tensorflow/python/framework/dtypes.py b/tensorflow/python/framework/dtypes.py
index e817c3172ee..eb7e8608569 100644
--- a/tensorflow/python/framework/dtypes.py
+++ b/tensorflow/python/framework/dtypes.py
@@ -18,7 +18,7 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import builtins
+import builtins
 
 from tensorflow.core.framework import types_pb2
 from tensorflow.python import pywrap_tensorflow
@@ -594,7 +594,7 @@ _TF_TO_NP = {
     # NOTE(touts): For strings we use np.object as it supports variable length
     # strings.
     types_pb2.DT_STRING:
-        np.object,
+        object,
     types_pb2.DT_COMPLEX64:
         np.complex64,
     types_pb2.DT_COMPLEX128:
@@ -602,7 +602,7 @@ _TF_TO_NP = {
     types_pb2.DT_INT64:
         np.int64,
     types_pb2.DT_BOOL:
-        np.bool,
+        bool,
     types_pb2.DT_QINT8:
         _np_qint8,
     types_pb2.DT_QUINT8:
@@ -636,7 +636,7 @@ _TF_TO_NP = {
     types_pb2.DT_INT8_REF:
         np.int8,
     types_pb2.DT_STRING_REF:
-        np.object,
+        object,
     types_pb2.DT_COMPLEX64_REF:
         np.complex64,
     types_pb2.DT_COMPLEX128_REF:
@@ -646,7 +646,7 @@ _TF_TO_NP = {
     types_pb2.DT_UINT64_REF:
         np.uint64,
     types_pb2.DT_BOOL_REF:
-        np.bool,
+        bool,
     types_pb2.DT_QINT8_REF:
         _np_qint8,
     types_pb2.DT_QUINT8_REF:
diff --git a/tensorflow/python/framework/errors_impl.py b/tensorflow/python/framework/errors_impl.py
index caaeab40254..9bc5e079f3c 100644
--- a/tensorflow/python/framework/errors_impl.py
+++ b/tensorflow/python/framework/errors_impl.py
@@ -506,7 +506,7 @@ _CODE_TO_EXCEPTION_CLASS = {
     DATA_LOSS: DataLossError,
 }
 
-c_api.PyExceptionRegistry_Init(_CODE_TO_EXCEPTION_CLASS)
+c_api.PyExceptionRegistry.Init(_CODE_TO_EXCEPTION_CLASS)
 
 _EXCEPTION_CLASS_TO_CODE = {
     class_: code for code, class_ in _CODE_TO_EXCEPTION_CLASS.items()}
diff --git a/tensorflow/python/framework/load_library.py b/tensorflow/python/framework/load_library.py
index 304745fe3c7..f4b334dbc7e 100644
--- a/tensorflow/python/framework/load_library.py
+++ b/tensorflow/python/framework/load_library.py
@@ -20,7 +20,7 @@ from __future__ import print_function
 
 import errno
 import hashlib
-import imp
+from importlib.util import spec_from_loader, module_from_spec
 import os
 import platform
 import sys
@@ -73,7 +73,8 @@ def load_op_library(library_filename):
   module_name = hashlib.md5(wrappers).hexdigest()
   if module_name in sys.modules:
     return sys.modules[module_name]
-  module = imp.new_module(module_name)
+  spec = spec_from_loader(module_name, loader=None)
+  module = module_from_spec(spec)
   # pylint: disable=exec-used
   exec(wrappers, module.__dict__)
   # Stash away the library handle for making calls into the dynamic library.
diff --git a/tensorflow/python/framework/ops.py b/tensorflow/python/framework/ops.py
index ec43d755c7b..cd5721a1a39 100644
--- a/tensorflow/python/framework/ops.py
+++ b/tensorflow/python/framework/ops.py
@@ -26,7 +26,6 @@ import threading
 
 import numpy as np
 import six
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.core.framework import attr_value_pb2
 from tensorflow.core.framework import function_pb2
@@ -172,7 +171,7 @@ def _override_helper(clazz_object, operator, func):
   if existing is not None:
     # Check to see if this is a default method-wrapper or slot wrapper which
     # will be true for the comparison operators.
-    if not isinstance(existing, type(object.__lt__)):
+    if not isinstance(existing, (type(object.__lt__), type(object().__lt__))):
       raise ValueError("operator %s cannot be overwritten again on class %s." %
                        (operator, clazz_object))
   if operator not in Tensor.OVERLOADABLE_OPERATORS:
@@ -554,7 +553,7 @@ class Tensor(_TensorLike):
     if shape[0] is None:
       raise TypeError(
           "Cannot iterate over a tensor with unknown first dimension.")
-    for i in xrange(shape[0]):
+    for i in range(shape[0]):
       yield self[i]
 
   def _shape_as_list(self):
@@ -1974,7 +1973,7 @@ class Operation(object):
     num_outputs = c_api.TF_OperationNumOutputs(self._c_op)
     output_types = [
         c_api.TF_OperationOutputType(self._tf_output(i))
-        for i in xrange(num_outputs)
+        for i in range(num_outputs)
     ]
     # In all the tests we have output_types that are passed into
     # Operation.__init__ are a list of ints (which is illegal according
@@ -2182,7 +2181,7 @@ class Operation(object):
     num_inputs = c_api.TF_OperationNumInputs(self._c_op)
     input_types = [
         dtypes.as_dtype(c_api.TF_OperationInputType(self._tf_input(i)))
-        for i in xrange(num_inputs)
+        for i in range(num_inputs)
     ]
     return input_types
 
diff --git a/tensorflow/python/framework/tensor_util.py b/tensorflow/python/framework/tensor_util.py
index 78807080616..9b520b94d84 100644
--- a/tensorflow/python/framework/tensor_util.py
+++ b/tensorflow/python/framework/tensor_util.py
@@ -103,9 +103,9 @@ if _FAST_TENSOR_UTIL_AVAILABLE:
           fast_tensor_util.AppendComplex64ArrayToTensorProto,
       np.complex128:
           fast_tensor_util.AppendComplex128ArrayToTensorProto,
-      np.object:
+      object:
           fast_tensor_util.AppendObjectArrayToTensorProto,
-      np.bool:
+      bool:
           fast_tensor_util.AppendBoolArrayToTensorProto,
       dtypes.qint8.as_numpy_dtype:
           fast_tensor_util.AppendInt8ArrayToTensorProto,
@@ -171,8 +171,8 @@ else:
       np.int16: SlowAppendIntArrayToTensorProto,
       np.complex64: SlowAppendComplex64ArrayToTensorProto,
       np.complex128: SlowAppendComplex128ArrayToTensorProto,
-      np.object: SlowAppendObjectArrayToTensorProto,
-      np.bool: SlowAppendBoolArrayToTensorProto,
+      object: SlowAppendObjectArrayToTensorProto,
+      bool: SlowAppendBoolArrayToTensorProto,
       dtypes.qint8.as_numpy_dtype: SlowAppendQIntArrayToTensorProto,
       dtypes.quint8.as_numpy_dtype: SlowAppendQIntArrayToTensorProto,
       dtypes.qint16.as_numpy_dtype: SlowAppendQIntArrayToTensorProto,
diff --git a/tensorflow/python/keras/datasets/cifar.py b/tensorflow/python/keras/datasets/cifar.py
index 02344897f77..eefa8a6065b 100644
--- a/tensorflow/python/keras/datasets/cifar.py
+++ b/tensorflow/python/keras/datasets/cifar.py
@@ -20,7 +20,7 @@ from __future__ import print_function
 
 import sys
 
-from six.moves import cPickle
+import pickle
 
 
 def load_batch(fpath, label_key='labels'):
@@ -36,9 +36,9 @@ def load_batch(fpath, label_key='labels'):
   """
   with open(fpath, 'rb') as f:
     if sys.version_info < (3,):
-      d = cPickle.load(f)
+      d = pickle.load(f)
     else:
-      d = cPickle.load(f, encoding='bytes')
+      d = pickle.load(f, encoding='bytes')
       # decode utf8
       d_decoded = {}
       for k, v in d.items():
diff --git a/tensorflow/python/keras/engine/base_layer.py b/tensorflow/python/keras/engine/base_layer.py
index 83e01dfa23e..15837d45cfb 100644
--- a/tensorflow/python/keras/engine/base_layer.py
+++ b/tensorflow/python/keras/engine/base_layer.py
@@ -25,7 +25,6 @@ import json
 import threading
 
 import numpy as np
-from six.moves import zip  # pylint: disable=redefined-builtin
 
 from google.protobuf import json_format
 from tensorflow.core.framework import node_def_pb2
diff --git a/tensorflow/python/keras/engine/input_spec.py b/tensorflow/python/keras/engine/input_spec.py
index d790af4798f..318f0a01749 100644
--- a/tensorflow/python/keras/engine/input_spec.py
+++ b/tensorflow/python/keras/engine/input_spec.py
@@ -18,7 +18,6 @@ from __future__ import absolute_import
 from __future__ import division
 from __future__ import print_function
 
-from six.moves import zip  # pylint: disable=redefined-builtin
 
 from tensorflow.python.framework import dtypes
 from tensorflow.python.framework import tensor_shape
diff --git a/tensorflow/python/keras/engine/network.py b/tensorflow/python/keras/engine/network.py
index 49a97ea9137..e11aa6290c0 100644
--- a/tensorflow/python/keras/engine/network.py
+++ b/tensorflow/python/keras/engine/network.py
@@ -27,7 +27,6 @@ import os
 import threading
 
 import numpy as np
-from six.moves import zip  # pylint: disable=redefined-builtin
 
 from tensorflow.python import pywrap_tensorflow
 from tensorflow.python.eager import context
diff --git a/tensorflow/python/keras/engine/training_utils.py b/tensorflow/python/keras/engine/training_utils.py
index b45bcbc5b3d..baad59bdaf4 100644
--- a/tensorflow/python/keras/engine/training_utils.py
+++ b/tensorflow/python/keras/engine/training_utils.py
@@ -27,7 +27,6 @@ import time
 
 import numpy as np
 import six
-from six.moves import zip  # pylint: disable=redefined-builtin
 
 from tensorflow.python import tf2
 from tensorflow.python.data.experimental.ops import cardinality
diff --git a/tensorflow/python/keras/optimizers.py b/tensorflow/python/keras/optimizers.py
index 10ce8336abc..5c2b4ccf955 100644
--- a/tensorflow/python/keras/optimizers.py
+++ b/tensorflow/python/keras/optimizers.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import six
-from six.moves import zip  # pylint: disable=redefined-builtin
 
 from tensorflow.python.distribute import distribution_strategy_context
 from tensorflow.python.framework import ops
diff --git a/tensorflow/python/keras/saving/hdf5_format.py b/tensorflow/python/keras/saving/hdf5_format.py
index d23db5b7763..9e4b74f1df4 100644
--- a/tensorflow/python/keras/saving/hdf5_format.py
+++ b/tensorflow/python/keras/saving/hdf5_format.py
@@ -23,7 +23,6 @@ import json
 import os
 
 import numpy as np
-from six.moves import zip  # pylint: disable=redefined-builtin
 
 from tensorflow.python.keras import backend as K
 from tensorflow.python.keras import optimizers
diff --git a/tensorflow/python/keras/utils/conv_utils.py b/tensorflow/python/keras/utils/conv_utils.py
index 1d6256ea3d8..35116b3511f 100644
--- a/tensorflow/python/keras/utils/conv_utils.py
+++ b/tensorflow/python/keras/utils/conv_utils.py
@@ -19,7 +19,6 @@ from __future__ import print_function
 
 import itertools
 import numpy as np
-from six.moves import range  # pylint: disable=redefined-builtin
 
 from tensorflow.python.keras import backend
 
@@ -416,7 +415,7 @@ def conv_connected_inputs(input_shape, kernel_shape, output_position, strides,
         >>> padding = "valid"
         >>> conv_connected_inputs(input_shape, kernel_shape, output_position,
         >>>                       strides, padding)
-        [xrange(1, 3), xrange(1, 2)]
+        [range(1, 3), range(1, 2)]
     ```
   Args:
     input_shape: tuple of size N: `(d_in1, ..., d_inN)`, spatial shape of the
diff --git a/tensorflow/python/keras/utils/data_utils.py b/tensorflow/python/keras/utils/data_utils.py
index 98b4929acde..0f4f11c51e0 100644
--- a/tensorflow/python/keras/utils/data_utils.py
+++ b/tensorflow/python/keras/utils/data_utils.py
@@ -37,9 +37,9 @@ import zipfile
 
 import numpy as np
 import six
-from six.moves.urllib.error import HTTPError
-from six.moves.urllib.error import URLError
-from six.moves.urllib.request import urlopen
+from urllib.error import HTTPError
+from urllib.error import URLError
+from urllib.request import urlopen
 
 from tensorflow.python.keras.utils.generic_utils import Progbar
 from tensorflow.python.util import tf_inspect
@@ -93,7 +93,7 @@ if sys.version_info[0] == 2:
       for chunk in chunk_read(response, reporthook=reporthook):
         fd.write(chunk)
 else:
-  from six.moves.urllib.request import urlretrieve
+  from urllib.request import urlretrieve
 
 
 def is_generator_or_sequence(x):
diff --git a/tensorflow/python/kernel_tests/basic_gpu_test.py b/tensorflow/python/kernel_tests/basic_gpu_test.py
index 789f6e90c9f..1ec1d08fff3 100644
--- a/tensorflow/python/kernel_tests/basic_gpu_test.py
+++ b/tensorflow/python/kernel_tests/basic_gpu_test.py
@@ -22,7 +22,6 @@ import itertools
 import threading
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.framework import dtypes
 from tensorflow.python.framework import ops
@@ -251,7 +250,7 @@ class GpuMultiSessionMemoryTest(test_util.TensorFlowTestCase):
         x4 = math_ops.matmul(array_ops.transpose(x3), x3, name='x4')
         s.run(variables.global_variables_initializer())
 
-        for _ in xrange(n_iterations):
+        for _ in range(n_iterations):
           value = s.run(x4)
           results.add(value.flat[0])
           if len(results) != 1:
@@ -262,7 +261,7 @@ class GpuMultiSessionMemoryTest(test_util.TensorFlowTestCase):
     n_threads = 4
     threads = []
     results = []
-    for _ in xrange(n_threads):
+    for _ in range(n_threads):
       session = self.session(graph=ops.Graph(), use_gpu=True)
       results.append(set())
       args = (session, results[-1])
diff --git a/tensorflow/python/kernel_tests/cholesky_op_test.py b/tensorflow/python/kernel_tests/cholesky_op_test.py
index e17a029c5ff..a65873a9e89 100644
--- a/tensorflow/python/kernel_tests/cholesky_op_test.py
+++ b/tensorflow/python/kernel_tests/cholesky_op_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.client import session
 from tensorflow.python.framework import constant_op
@@ -130,13 +129,13 @@ class CholeskyOpTest(test.TestCase):
 
     # Generate random positive-definite matrices.
     matrices = np.random.rand(10, 5, 5)
-    for i in xrange(10):
+    for i in range(10):
       matrices[i] = np.dot(matrices[i].T, matrices[i])
     self._verifyCholesky(matrices)
 
     # Generate random complex valued positive-definite matrices.
     matrices = np.random.rand(10, 5, 5) + 1j * np.random.rand(10, 5, 5)
-    for i in xrange(10):
+    for i in range(10):
       matrices[i] = np.dot(matrices[i].T.conj(), matrices[i])
     self._verifyCholesky(matrices)
 
diff --git a/tensorflow/python/kernel_tests/confusion_matrix_test.py b/tensorflow/python/kernel_tests/confusion_matrix_test.py
index cd6bd29e0de..3f29642f5de 100644
--- a/tensorflow/python/kernel_tests/confusion_matrix_test.py
+++ b/tensorflow/python/kernel_tests/confusion_matrix_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.framework import dtypes
 from tensorflow.python.framework import errors_impl
@@ -106,7 +105,7 @@ class ConfusionMatrixTest(test.TestCase):
       d, l, cm_out = sess.run([data, lab, cm], {m_neg: 0.0, m_pos: 1.0, s: 1.0})
 
       truth = np.zeros([2, 2], dtype=np_dtype)
-      for i in xrange(len(d)):
+      for i in range(len(d)):
         truth[l[i], d[i]] += 1
 
       self.assertEqual(cm_out.dtype, np_dtype)
diff --git a/tensorflow/python/kernel_tests/control_flow_ops_py_test.py b/tensorflow/python/kernel_tests/control_flow_ops_py_test.py
index 4b420e60b98..2abe3c227f9 100644
--- a/tensorflow/python/kernel_tests/control_flow_ops_py_test.py
+++ b/tensorflow/python/kernel_tests/control_flow_ops_py_test.py
@@ -28,7 +28,6 @@ import time
 
 from absl.testing import parameterized
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.core.protobuf import config_pb2
 from tensorflow.python.client import device_lib
@@ -2728,7 +2727,7 @@ class ControlFlowTest(test.TestCase, parameterized.TestCase):
 
       r = control_flow_ops.while_loop(c, b, [i], parallel_iterations=1)
       self.assertEqual([10], self.evaluate(r))
-      for i in xrange(10):
+      for i in range(10):
         self.assertEqual([i], self.evaluate(q.dequeue()))
 
   @test_util.run_v1_only("b/120545219")
@@ -4886,7 +4885,7 @@ class WhileOpBenchmark(test.Benchmark):
       variables.global_variables_initializer().run()
 
       if static_unroll:
-        for _ in xrange(steps):
+        for _ in range(steps):
           i, x = loop_body(i, x)
       else:
         i, x = control_flow_ops.while_loop(
@@ -4900,12 +4899,12 @@ class WhileOpBenchmark(test.Benchmark):
       # Use group to avoid fetching back results.
       r = control_flow_ops.group(dx, dk)
 
-      for _ in xrange(3):
+      for _ in range(3):
         # exclude warm up time
         self.evaluate(r)
 
       start_time = time.time()
-      for _ in xrange(num_iters):
+      for _ in range(num_iters):
         self.evaluate(r)
       return (time.time() - start_time) / num_iters
 
diff --git a/tensorflow/python/kernel_tests/conv1d_test.py b/tensorflow/python/kernel_tests/conv1d_test.py
index 5ac8c11130b..55bccc83757 100644
--- a/tensorflow/python/kernel_tests/conv1d_test.py
+++ b/tensorflow/python/kernel_tests/conv1d_test.py
@@ -18,7 +18,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.framework import constant_op
 from tensorflow.python.framework import dtypes
@@ -79,9 +78,9 @@ class Conv1DTest(test.TestCase):
       # The amount of padding added
       pad = 1
 
-      for n in xrange(x_shape[0]):
-        for k in xrange(f_shape[1]):
-          for w in xrange(pad, y_shape[1] - pad):
+      for n in range(x_shape[0]):
+        for k in range(f_shape[1]):
+          for w in range(pad, y_shape[1] - pad):
             target = 3.0
             # We add a case for locations divisible by the stride.
             w_in = w % stride == 0 and w > pad and w < y_shape[1] - 1 - pad
diff --git a/tensorflow/python/kernel_tests/conv1d_transpose_test.py b/tensorflow/python/kernel_tests/conv1d_transpose_test.py
index 02ac5af7aae..2100665cbb5 100644
--- a/tensorflow/python/kernel_tests/conv1d_transpose_test.py
+++ b/tensorflow/python/kernel_tests/conv1d_transpose_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.framework import constant_op
 from tensorflow.python.framework import dtypes
@@ -51,9 +50,9 @@ class Conv1DTransposeTest(test.TestCase):
           x, f, y_shape, strides=strides, padding="SAME")
       value = self.evaluate(output)
 
-      for n in xrange(y_shape[0]):
-        for w in xrange(y_shape[1]):
-          for c in xrange(y_shape[2]):
+      for n in range(y_shape[0]):
+        for w in range(y_shape[1]):
+          for c in range(y_shape[2]):
             target = 2 * 3.0
             w_in = w > 0 and w < y_shape[1] - 1
             if w_in:
@@ -79,9 +78,9 @@ class Conv1DTransposeTest(test.TestCase):
           x, f, y_shape, strides=strides, padding="SAME")
       value = self.evaluate(output)
 
-      for n in xrange(x_shape[0]):
-        for k in xrange(f_shape[1]):
-          for w in xrange(y_shape[1]):
+      for n in range(x_shape[0]):
+        for k in range(f_shape[1]):
+          for w in range(y_shape[1]):
             target = 3.0
             # We add a case for locations divisible by the stride.
             w_in = w % strides[1] == 0 and w > 0 and w < y_shape[1] - 1
@@ -113,9 +112,9 @@ class Conv1DTransposeTest(test.TestCase):
       # The amount of padding added
       pad = 1
 
-      for n in xrange(x_shape[0]):
-        for k in xrange(f_shape[1]):
-          for w in xrange(pad, y_shape[1] - pad):
+      for n in range(x_shape[0]):
+        for k in range(f_shape[1]):
+          for w in range(pad, y_shape[1] - pad):
             target = 3.0
             # We add a case for locations divisible by the stride.
             w_in = w % strides[1] == 0 and w > pad and w < y_shape[1] - 1 - pad
@@ -172,9 +171,9 @@ class Conv1DTransposeTest(test.TestCase):
             x, f, y_shape, strides=strides, padding="SAME", data_format="NCW")
 
         value = self.evaluate(output)
-        for n in xrange(x_shape[0]):
-          for k in xrange(f_shape[1]):
-            for w in xrange(y_shape[2]):
+        for n in range(x_shape[0]):
+          for k in range(f_shape[1]):
+            for w in range(y_shape[2]):
               target = 2 * 3.0
               w_in = w > 0 and w < y_shape[2] - 1
               if w_in:
@@ -203,9 +202,9 @@ class Conv1DTransposeTest(test.TestCase):
             x, f, y_shape, strides=strides, padding="SAME", data_format="NCW")
 
         value = self.evaluate(output)
-        for n in xrange(x_shape[0]):
-          for k in xrange(f_shape[1]):
-            for w in xrange(y_shape[2]):
+        for n in range(x_shape[0]):
+          for k in range(f_shape[1]):
+            for w in range(y_shape[2]):
               target = 3.0
               # We add a case for locations divisible by the stride.
               w_in = w % strides[2] == 0 and w > 0 and w < y_shape[2] - 1
@@ -237,9 +236,9 @@ class Conv1DTransposeTest(test.TestCase):
         cache_values = np.zeros(y_shape, dtype=np.float32)
         # The amount of padding added
         pad = 1
-        for n in xrange(x_shape[0]):
-          for k in xrange(f_shape[1]):
-            for w in xrange(pad, y_shape[2] - pad):
+        for n in range(x_shape[0]):
+          for k in range(f_shape[1]):
+            for w in range(pad, y_shape[2] - pad):
               target = 3.0
               # We add a case for locations divisible by the stride.
               w_in = w % strides[2] == 0 and w > pad and \
diff --git a/tensorflow/python/kernel_tests/conv2d_transpose_test.py b/tensorflow/python/kernel_tests/conv2d_transpose_test.py
index c603c086306..695dc30e854 100644
--- a/tensorflow/python/kernel_tests/conv2d_transpose_test.py
+++ b/tensorflow/python/kernel_tests/conv2d_transpose_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.framework import constant_op
 from tensorflow.python.framework import dtypes
@@ -61,10 +60,10 @@ class Conv2DTransposeTest(test.TestCase):
       # At the borders, #cells=ceil(kernel_height/2)*kernel_width or
       #                        kernel_height * ceil(kernel_width/2)
 
-      for n in xrange(x_shape[0]):
-        for k in xrange(f_shape[2]):
-          for w in xrange(y_shape[2]):
-            for h in xrange(y_shape[1]):
+      for n in range(x_shape[0]):
+        for k in range(f_shape[2]):
+          for w in range(y_shape[2]):
+            for h in range(y_shape[1]):
               target = 4 * 3.0
               h_in = h > 0 and h < y_shape[1] - 1
               w_in = w > 0 and w < y_shape[2] - 1
@@ -93,10 +92,10 @@ class Conv2DTransposeTest(test.TestCase):
           x, f, y_shape, strides=strides, padding="SAME")
       value = self.evaluate(output)
 
-      for n in xrange(x_shape[0]):
-        for k in xrange(f_shape[2]):
-          for w in xrange(y_shape[2]):
-            for h in xrange(y_shape[1]):
+      for n in range(x_shape[0]):
+        for k in range(f_shape[2]):
+          for w in range(y_shape[2]):
+            for h in range(y_shape[1]):
               target = 3.0
               # We add a case for locations divisible by the stride.
               h_in = h % strides[1] == 0 and h > 0 and h < y_shape[1] - 1
@@ -131,10 +130,10 @@ class Conv2DTransposeTest(test.TestCase):
       # The amount of padding added
       pad = 1
 
-      for n in xrange(x_shape[0]):
-        for k in xrange(f_shape[2]):
-          for w in xrange(pad, y_shape[2] - pad):
-            for h in xrange(pad, y_shape[1] - pad):
+      for n in range(x_shape[0]):
+        for k in range(f_shape[2]):
+          for w in range(pad, y_shape[2] - pad):
+            for h in range(pad, y_shape[1] - pad):
               target = 3.0
               # We add a case for locations divisible by the stride.
               h_in = h % strides[1] == 0 and h > pad and h < y_shape[
@@ -197,10 +196,10 @@ class Conv2DTransposeTest(test.TestCase):
             x, f, y_shape, strides=strides, padding="SAME", data_format="NCHW")
 
         value = self.evaluate(output)
-        for n in xrange(x_shape[0]):
-          for k in xrange(f_shape[2]):
-            for w in xrange(y_shape[3]):
-              for h in xrange(y_shape[2]):
+        for n in range(x_shape[0]):
+          for k in range(f_shape[2]):
+            for w in range(y_shape[3]):
+              for h in range(y_shape[2]):
                 target = 4 * 3.0
                 h_in = h > 0 and h < y_shape[2] - 1
                 w_in = w > 0 and w < y_shape[3] - 1
@@ -232,10 +231,10 @@ class Conv2DTransposeTest(test.TestCase):
             x, f, y_shape, strides=strides, padding="SAME", data_format="NCHW")
 
         value = self.evaluate(output)
-        for n in xrange(x_shape[0]):
-          for k in xrange(f_shape[2]):
-            for w in xrange(y_shape[3]):
-              for h in xrange(y_shape[2]):
+        for n in range(x_shape[0]):
+          for k in range(f_shape[2]):
+            for w in range(y_shape[3]):
+              for h in range(y_shape[2]):
                 target = 3.0
                 # We add a case for locations divisible by the stride.
                 h_in = h % strides[2] == 0 and h > 0 and h < y_shape[2] - 1
@@ -270,10 +269,10 @@ class Conv2DTransposeTest(test.TestCase):
         cache_values = np.zeros(y_shape, dtype=np.float32)
         # The amount of padding added
         pad = 1
-        for n in xrange(x_shape[0]):
-          for k in xrange(f_shape[2]):
-            for w in xrange(pad, y_shape[3] - pad):
-              for h in xrange(pad, y_shape[2] - pad):
+        for n in range(x_shape[0]):
+          for k in range(f_shape[2]):
+            for w in range(pad, y_shape[3] - pad):
+              for h in range(pad, y_shape[2] - pad):
                 target = 3.0
                 # We add a case for locations divisible by the stride.
                 h_in = h % strides[2] == 0 and h > pad and h < y_shape[
